SystemOrganization addCategory: #TPDBZ!
SystemOrganization addCategory: #'TPDBZ-Tests'!

TestCase subclass: #AliadosTest
	instanceVariableNames: 'freezer cell krillin goku vegeta yamcha bulma milk videl maestroRoshi tenShinHan'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ-Tests'!

!AliadosTest commentStamp: '<historical>' prior: 0!
A GuerreroTest is a test class for testing the behavior of Guerrero!

!AliadosTest methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/24/2013 01:11'!
setUp
goku:= Saiyajin newConpoderesAprendidos: (Bag new) nivelDePelea: 110000 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0.
goku tipo: (TipoBueno new).
vegeta:= Saiyajin newConpoderesAprendidos: (Bag new) nivelDePelea: 90000 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0.
vegeta tipo: (TipoMalo new).
freezer:= Monstruo newConpoderesAprendidos: (Bag new) nivelDePelea: 100000 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0.
cell:= Monstruo newConpoderesAprendidos: (Bag new) nivelDePelea: 100000 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0.
krillin:= Terricola newConpoderesAprendidos: (Bag new) nivelDePelea: 20000 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0.
yamcha:= Terricola newConpoderesAprendidos: (Bag new) nivelDePelea: 20 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0. 
bulma:= Terricola newConpoderesAprendidos: (Bag new) nivelDePelea: 2 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0.
milk:= Terricola newConpoderesAprendidos: (Bag new) nivelDePelea: 2 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0. 
videl:= Terricola newConpoderesAprendidos: (Bag new) nivelDePelea: 14000 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0.
maestroRoshi:= Terricola newConpoderesAprendidos: (Bag new) nivelDePelea: 14000 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0. 
tenShinHan:= Terricola newConpoderesAprendidos: (Bag new) nivelDePelea: 14000 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0. ! !

!AliadosTest methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/24/2013 01:07'!
testAlianzaInfalibleMonstruo

self assert: ({ krillin.videl.goku.vegeta.cell.milk.bulma. yamcha.maestroRoshi.tenShinHan} inject: true into: [ :acum :unPersonaje | (freezer aceptaA: unPersonaje) & acum ]).! !

!AliadosTest methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/24/2013 01:13'!
testAlianzaSaijyajinConDebil

self assert: (goku aceptaA: cell)! !

!AliadosTest methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/24/2013 01:13'!
testAlianzaSaijyajinConFuertes

cell aliarseCon: freezer.

self deny: (goku aceptaA: cell)! !

!AliadosTest methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/24/2013 01:14'!
testAlianzaTerricolaCon5BuenosDebiles

krillin aliarseCon: yamcha.
krillin aliarseCon: videl.
krillin aliarseCon: bulma.
krillin aliarseCon: maestroRoshi.


self assert: (krillin puedeAliarseCon: milk ).! !

!AliadosTest methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/24/2013 01:01'!
testAlianzaTerricolaCon6BuenosDebiles

krillin aliarseCon: yamcha.
krillin aliarseCon: videl.
krillin aliarseCon: bulma.
krillin aliarseCon: maestroRoshi.
krillin aliarseCon: tenShinHan.

self deny: (krillin puedeAliarseCon: milk ).! !

!AliadosTest methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/17/2013 23:52'!
testAlianzaTerricolaConBuenoFuerte

self assert: (krillin puedeAliarseCon: goku)
! !

!AliadosTest methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/17/2013 23:31'!
testAlianzaTerricolaConMalo

self deny: (krillin puedeAliarseCon: freezer).! !

TestCase subclass: #PoderesTest
	instanceVariableNames: 'freezer cell krillin goku vegeta yamcha bulma milk videl maestroRoshi tenShinHan kameHameHa finalFlash taioKen makankosappo genkidama'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ-Tests'!

!PoderesTest methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 14:19'!
setUp
goku:= Saiyajin newConpoderesAprendidos: (Bag new) nivelDePelea: 110000 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0.
	goku tipo: (TipoBueno new).

vegeta:= Saiyajin newConpoderesAprendidos: (Bag new) nivelDePelea: 90000 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0.
	vegeta tipo: (TipoBueno new).

freezer:= Monstruo newConpoderesAprendidos: (Bag new) nivelDePelea: 100000 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0.

cell:= Monstruo newConpoderesAprendidos: (Bag new) nivelDePelea: 100000 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0.

krillin:= Terricola newConpoderesAprendidos: (Bag new) nivelDePelea: 20000 cantidadDeEnergia:  10000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0.

yamcha:= Terricola newConpoderesAprendidos: (Bag new) nivelDePelea: 20 cantidadDeEnergia:  10 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0. 

bulma:= Terricola newConpoderesAprendidos: (Bag new) nivelDePelea: 2 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0.

milk:= Terricola newConpoderesAprendidos: (Bag new) nivelDePelea: 2 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0. 

videl:= Terricola newConpoderesAprendidos: (Bag new) nivelDePelea: 14000 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0.

maestroRoshi:= Terricola newConpoderesAprendidos: (Bag new) nivelDePelea: 14000 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0. 

tenShinHan:= Terricola newConpoderesAprendidos: (Bag new) nivelDePelea: 14000 cantidadDeEnergia:  1000 puntosDeVida: 50000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0. 

kameHameHa:=PoderPotente newConPotencia: 5.

PoderVengativo energiaQueConsume: 150.

finalFlash:= PoderVengativo newConAliadosMuertosNecesarios: 1 .

makankosappo:= PoderPotente newConPotencia: 3.

taioKen:= PoderLiviano newConPuntosDeAtaque: 75.

genkidama:= PoderColectivo newConAliadosNecesarios: 5 energiaNecesariaPorAliado: 50.


! !

!PoderesTest methodsFor: 'poderHacerPoderes' stamp: 'RodolfoCaputo 10/25/2013 02:43'!
test25porcientoEnergiaAtacatePotente

self assert: (makankosappo energiaQueConsumeDe: krillin ) equals: 2500.

! !

!PoderesTest methodsFor: 'poderHacerPoderes' stamp: 'RodolfoCaputo 10/25/2013 14:10'!
testColectivoConAliadosBien

{ krillin .bulma .milk. tenShinHan .maestroRoshi } do: [ :alguien |goku aliarseCon: alguien ].

goku aprende: genkidama.

self assert: (goku puedeHacer: genkidama)! !

!PoderesTest methodsFor: 'poderHacerPoderes' stamp: 'RodolfoCaputo 10/25/2013 02:45'!
testColectivoPocosAliados

self deny: (goku puedeHacer: genkidama)! !

!PoderesTest methodsFor: 'puntosAtaque' stamp: 'RodolfoCaputo 10/25/2013 17:14'!
testColectivoPtosAtaque

{ krillin .bulma .milk. tenShinHan .maestroRoshi } do: [ :alguien |goku aliarseCon: alguien ].

goku aprende: genkidama.

self assert: (genkidama puntosAtaquePara: goku) equals: (5*50+200)! !

!PoderesTest methodsFor: 'poderHacerPoderes' stamp: 'RodolfoCaputo 10/25/2013 02:32'!
testLivianoEnergaMenor50

yamcha aprende: taioKen.

self deny: (yamcha puedeHacer: taioKen)! !

!PoderesTest methodsFor: 'poderHacerPoderes' stamp: 'RodolfoCaputo 10/25/2013 02:29'!
testNoLoAprendio

self deny:(goku puedeHacer: makankosappo)! !

!PoderesTest methodsFor: 'puntosAtaque' stamp: 'RodolfoCaputo 10/25/2013 02:38'!
testPtosATaqueLiviano

self assert: (taioKen puntosDeAtaquePara:  vegeta) equals: 75.

! !

!PoderesTest methodsFor: 'puntosAtaque' stamp: 'RodolfoCaputo 10/25/2013 15:14'!
testPtosATaqueVengativo

vegeta aprende: finalFlash.

{ krillin .bulma  } do: [ :alguien |vegeta aliarseCon: alguien ].

bulma puntosDeVida: -5.

self assert:(finalFlash puntosDeAtaquePara: vegeta) equals: 250.! !

!PoderesTest methodsFor: 'poderHacerPoderes' stamp: 'RodolfoCaputo 10/25/2013 02:27'!
testTerrcolaMasDe500Energia

krillin aprende:  kameHameHa.

self deny: ( krillin puedeHacer:  kameHameHa)! !

!PoderesTest methodsFor: 'poderHacerPoderes' stamp: 'RodolfoCaputo 10/25/2013 14:18'!
testVengativoConAliadosComoDebe

vegeta aprende: finalFlash.

{ krillin .bulma  } do: [ :alguien |vegeta aliarseCon: alguien ].

bulma puntosDeVida: -5.

self assert:(vegeta puedeHacer: finalFlash).! !

!PoderesTest methodsFor: 'poderHacerPoderes' stamp: 'RodolfoCaputo 10/25/2013 14:22'!
testVengativoConPocaEnerga

vegeta aprende: finalFlash.

{ krillin .bulma  } do: [ :alguien |vegeta aliarseCon: alguien ].

bulma puntosDeVida: -5.

vegeta cantidadDeEnergia: 140.

self deny:(vegeta puedeHacer: finalFlash).! !

!PoderesTest methodsFor: 'poderHacerPoderes' stamp: 'RodolfoCaputo 10/25/2013 14:19'!
testVengativoFaltaAliadoVivo

vegeta aprende: finalFlash.

{ krillin .bulma  } do: [ :alguien |vegeta aliarseCon: alguien ].

bulma puntosDeVida: -5.

krillin puntosDeVida: -10000.

self deny:(vegeta puedeHacer: finalFlash).! !

!PoderesTest methodsFor: 'poderHacerPoderes' stamp: 'RodolfoCaputo 10/25/2013 14:15'!
testVengativoSinAliadosMuertosYvivos

vegeta aprende: finalFlash.

self deny:(vegeta puedeHacer: finalFlash)! !

!PoderesTest methodsFor: 'poderHacerPoderes' stamp: 'RodolfoCaputo 10/25/2013 02:43'!
testptosAtaqueAtacatePotente

self assert: (makankosappo puntosDeAtaquePara: krillin ) equals: (20000/500*3).

! !

TestCase subclass: #SemillasTest
	instanceVariableNames: 'goku majinBoo yamcha turles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ-Tests'!

!SemillasTest methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/27/2013 22:13'!
setUp
	

	yamcha := Terricola newConpoderesAprendidos: (Bag new) nivelDePelea: 400 cantidadDeEnergia:  1000 puntosDeVida: 2000  aliados: (Bag new) traje:  (NoTraje new) esferas: (Bag new) semillasDelHermitanio: 0.
	
	majinBoo := Monstruo newConpoderesAprendidos: (Bag new) nivelDePelea: 4000 cantidadDeEnergia:  1000 puntosDeVida: 2000  aliados: (Bag new) traje:  (NoTraje new) esferas: (Bag new) semillasDelHermitanio: 0.
	
	goku := Saiyajin newConpoderesAprendidos: (Bag new) nivelDePelea: 9001 cantidadDeEnergia:  100 puntosDeVida: 20  aliados: (Bag new) traje:  (NoTraje new) esferas: (Bag new) semillasDelHermitanio: 0.
	
	turles := Saiyajin newConpoderesAprendidos: (Bag new) nivelDePelea: 9001 cantidadDeEnergia:  100 puntosDeVida: 20  aliados: (Bag new) traje:  (NoTraje new) esferas: (Bag new) semillasDelHermitanio: 0.
	
	goku tipo: (TipoBueno new).
	goku aliarseCon: yamcha.
	goku aliarseCon: majinBoo .
	! !

!SemillasTest methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/27/2013 22:09'!
testComerMendigandoAMonstruo

	majinBoo semillasDelHermitanio: 2.
	goku intentarComerSemilla.
	
self assert: ((goku puntosDeVida = 1000) & (goku semillasDelHermitanio = 0) & (goku cantidadDeEnergia = 750.05)).! !

!SemillasTest methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/27/2013 21:34'!
testComerMendigandoATerricola

	yamcha semillasDelHermitanio: 1.
	goku intentarComerSemilla.
	
self assert: ((goku puntosDeVida = 1000) & (goku semillasDelHermitanio = 0) & (goku cantidadDeEnergia = 750.05)).! !

!SemillasTest methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/27/2013 21:41'!
testComerNormal

	goku semillasDelHermitanio: 1.
	goku intentarComerSemilla.
	
self assert: (goku puntosDeVida = 1000).
self assert: (goku semillasDelHermitanio = 0). 
self assert: (goku cantidadDeEnergia = 750.05).! !

!SemillasTest methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/27/2013 22:13'!
testNoPudoComerDeDesconocido

	turles semillasDelHermitanio: 1.

self deny: (goku tieneSemillasDisponibles).! !

!SemillasTest methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/27/2013 22:12'!
testNoPudoComerDeMonstruo

	majinBoo semillasDelHermitanio: 1.

self deny: (goku tieneSemillasDisponibles).! !

!SemillasTest methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/27/2013 22:14'!
testNoPudoComerDeTerricola

	yamcha semillasDelHermitanio: 0.

self deny: (goku tieneSemillasDisponibles).! !

TestCase subclass: #TrajesTest
	instanceVariableNames: 'krillin freezer trajeKame trajeSaiyan hombrerasNamek calvaDeKrillin cuernoAlPecho cuerpoChanglong'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ-Tests'!

!TrajesTest methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/25/2013 20:57'!
setUp

freezer:= Monstruo newConpoderesAprendidos: (Bag new) nivelDePelea: 100000 cantidadDeEnergia:  10000 puntosDeVida: 5000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0.

krillin:= Terricola newConpoderesAprendidos: (Bag new) nivelDePelea: 200 cantidadDeEnergia:  1000 puntosDeVida: 5000  aliados: (Bag new) traje:  (Traje new) esferas: (Bag new) semillasDelHermitanio: 0.

cuernoAlPecho := PoderLiviano newConPuntosDeAtaque: 1000.

trajeKame := Traje new.
trajeSaiyan := TrajeEspecial new.
hombrerasNamek := TrajeEntrenamiento new.
hombrerasNamek ataquesRecibidos: 0.
calvaDeKrillin := NoTraje new.
cuerpoChanglong := NoTraje new.

freezer traje: cuerpoChanglong.

freezer aprende: cuernoAlPecho.
! !

!TrajesTest methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/25/2013 20:12'!
testKrillinVsFreezerNoTraje


freezer traje: cuerpoChanglong.

freezer aprende: cuernoAlPecho.

krillin traje: calvaDeKrillin.

freezer atacarA: krillin con: cuernoAlPecho.

self assert: (krillin puntosDeVida =  4050).! !

!TrajesTest methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/25/2013 21:02'!
testKrillinVsFreezerTrajeEntrenamiento

krillin traje: hombrerasNamek.

freezer atacarA: krillin con: cuernoAlPecho.
freezer atacarA: krillin con: cuernoAlPecho.
freezer atacarA: krillin con: cuernoAlPecho.
freezer atacarA: krillin con: cuernoAlPecho.

self assert: (krillin puntosDeVida =  1580) .
self assert: (krillin nivelDePelea = 300) .
self assert:  (krillin cantidadDeEnergia = 920).! !

!TrajesTest methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/25/2013 15:13'!
testKrillinVsFreezerTrajeEspecial

krillin traje: trajeSaiyan.

freezer atacarA: krillin con: cuernoAlPecho.

self assert: (krillin puntosDeVida =  4164).! !

!TrajesTest methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/25/2013 15:22'!
testKrillinVsFreezerTrajeNormal

krillin traje: trajeKame.

freezer atacarA: krillin con: cuernoAlPecho.

self assert: (krillin puntosDeVida =  4145).! !

Object subclass: #Esfera
	instanceVariableNames: 'estrellas estado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Esfera class methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/28/2013 01:17'!
newConEstrellas: unNroDeEstrellas
|unaEsfera|
unaEsfera:=self new.
unaEsfera estado: EstadoNueva new.
unaEsfera estrellas: unNroDeEstrellas.
unaEsfera estado: EstadoTerminada new.
Guerrero agregarEsfera: unaEsfera.
^unaEsfera.
! !

!Esfera methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/28/2013 01:09'!
estado
	^ estado! !

!Esfera methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/28/2013 01:09'!
estado: anObject
	estado := anObject! !

!Esfera methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/25/2013 23:34'!
estrellas
	^ estrellas! !

!Esfera methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/28/2013 01:12'!
estrellas: unaCantidad
^(self estado) cargar: unaCantidad estrellasA: self! !

Object subclass: #EstadoNueva
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!EstadoNueva methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/28/2013 01:11'!
cargar: unaCantidad estrellasA: unaEsfera
	(unaCantidad<0 | unaCantidad>7) ifTrue:[ self error: 'Por muchas esferas berreta que quieras inventar, Shen Long no va a venir'].
	unaEsfera estrellas: unaCantidad.! !

Object subclass: #EstadoTerminada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!EstadoTerminada methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/28/2013 01:11'!
cargar: unaCantidad estrellasA: unaEsfera
^self error: 'Por muchas esferas berreta que quieras inventar, Shen Long no va a venir'
	! !

Object subclass: #Guerrero
	instanceVariableNames: 'poderesAprendidos nivelDePelea cantidadDeEnergia puntosDeVida aliados traje esferas semillasDelHermitanio tipo enemigos'
	classVariableNames: 'esferasExistentes'
	poolDictionaries: ''
	category: 'TPDBZ'!

!Guerrero class methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/28/2013 01:17'!
agregarEsfera:unaEsfera
^ self esferasExistentes add: unaEsfera! !

!Guerrero class methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/28/2013 01:15'!
esferasExistentes
	^ esferasExistentes! !

!Guerrero class methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/28/2013 01:15'!
esferasExistentes: anObject
	esferasExistentes := anObject! !

!Guerrero class methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/17/2013 23:17'!
newConpoderesAprendidos:unosPoderes nivelDePelea: unNivel cantidadDeEnergia: unosJoules puntosDeVida: unosPuntos aliados: unosAliados traje:unTraje esferas: unasEsferas semillasDelHermitanio: unasSemillas
|unGuerrero|

unGuerrero:= self new.

unGuerrero poderesAprendidos: unosPoderes.
unGuerrero nivelDePelea:unNivel.
unGuerrero cantidadDeEnergia: unosJoules.
unGuerrero puntosDeVida: unosPuntos.
unGuerrero aliados: unosAliados.
unGuerrero traje: unTraje.
unGuerrero esferas: unasEsferas .
unGuerrero semillasDelHermitanio: unasSemillas.

^unGuerrero! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'RodolfoCaputo 10/17/2013 22:35'!
aceptaA: unGuerrero 
^(self aceptariaA: unGuerrero) & (self~=unGuerrero)& ((self aliados includes: unGuerrero) not)! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'RodolfoCaputo 10/14/2013 01:23'!
agregarAliado: unGuerrero
self aliados add: unGuerrero! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/28/2013 01:44'!
agregarEnemigo: unGuerrero
self enemigos add: unGuerrero.! !

!Guerrero methodsFor: 'esferas' stamp: 'ricardocascallares 10/25/2013 19:59'!
agregarEsfera: unaEsfera 
self esferas add: unaEsfera ! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'RodolfoCaputo 10/25/2013 22:46'!
aliadoVivo
^self aliados select: [ :unAliado | unAliado estaVivo  ] anyOne! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'RodolfoCaputo 10/28/2013 02:19'!
aliadoVivoMasFuerte 
self aliadosVivos detectMax: [ :unAliado | unAliado nivelDePelea ]! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:55'!
aliados
	^ aliados! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:55'!
aliados: anObject
	aliados := anObject! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'RodolfoCaputo 10/24/2013 22:16'!
aliadosMuertos 
^self aliados select:[ :unAliado | unAliado estaMuerto]! !

!Guerrero methodsFor: 'semillas' stamp: 'LoguancioMartin 10/27/2013 22:02'!
aliadosQueCedenUnaSemilla
^aliados select: [ :unAliado| unAliado cedeUnaSemilla ].! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'RodolfoCaputo 10/28/2013 01:42'!
aliadosVivos
self grupoDeVivosDe: (self aliados)! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'ricardoCascallares 10/24/2013 22:29'!
aliadosVivosCon: unaCantidadDeEnergia
^(self aliadosVivos select: [ :unAliadoVivo | unAliadoVivo tieneAlMenos: unaCantidadDeEnergia ] ) ! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'RodolfoCaputo 10/14/2013 17:54'!
aliarseCon: unGuerrero
(self puedeAliarseCon: unGuerrero) ifTrue:[ self concretarAlianzaCon: unGuerrero ] ifFalse: [ self error: 'Imposible realizar la alianza pedida' ].! !

!Guerrero methodsFor: 'poderes' stamp: 'LoguancioMartin 10/21/2013 20:11'!
aprende: unPoder 
^(self poderesAprendidos) add: unPoder. ! !

!Guerrero methodsFor: 'ataques(uso)' stamp: 'RodolfoCaputo 10/28/2013 01:44'!
atacarA: unGuerrero con: unPoder
((self puedeHacer: unPoder) & (unGuerrero noEsAliadoDe: self )) ifFalse: [ self error: 'El atacante no est en condiciones de realizar el poder especificado, dele de comer que tiene hambre'].
unGuerrero recibir: unPoder de: self.
(unGuerrero estaMuerto | unGuerrero estaMoribundo) ifTrue:[self tomarEsferasDe: unGuerrero].
unPoder generarConsecuenciasEn: self.
self agregarEnemigo: unGuerrero.! !

!Guerrero methodsFor: 'ataques(uso)' stamp: 'LoguancioMartin 10/27/2013 20:32'!
atacarConAlMenos: unosPuntosDeAtaque A: unGuerrero
self atacarA: unGuerrero  con: (self poderDeAlMenos:unosPuntosDeAtaque para: unGuerrero ).
! !

!Guerrero methodsFor: 'ataques(uso)' stamp: 'ricardoCascallares 10/27/2013 21:09'!
atacarConCualquierPoderA: unGuerrero
self atacarA: unGuerrero  con: (self poderesQuePuedeHacer anyOne )
! !

!Guerrero methodsFor: 'ataques(uso)' stamp: 'RodolfoCaputo 10/28/2013 21:36'!
atacarConPoderMasFuerteA: unGuerrero
self atacarA: unGuerrero  con: (self poderMasFuerteParaAtacarA:unGuerrero )
! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/25/2013 02:49'!
cantAliadosVivosCon: unaCantidadDeEnergia
^(self aliadosVivosCon: unaCantidadDeEnergia) size! !

!Guerrero methodsFor: 'esferas' stamp: 'RodolfoCaputo 10/28/2013 01:38'!
cantPotencialesReceptores
^self potencialesReceptores size! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'RodolfoCaputo 10/24/2013 22:17'!
cantidadAliadosMuertos
^ self aliadosMuertos size! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'ricadocascallares 10/17/2013 20:55'!
cantidadAliadosVivos
^ self aliadosVivos size! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
cantidadDeEnergia
	^ cantidadDeEnergia! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
cantidadDeEnergia: anObject
	cantidadDeEnergia := anObject! !

!Guerrero methodsFor: 'semillas' stamp: 'LoguancioMartin 10/27/2013 21:38'!
cedeUnaSemilla
^ (self tipo) puededarUnaSemilla: self .! !

!Guerrero methodsFor: 'semillas' stamp: 'Solange 10/27/2013 22:28'!
comerSemillaDeHermitanio
(semillasDelHermitanio >0)
ifTrue: [ self quitarUnaSemilla ] 
ifFalse: [ (( self aliadosQueCedenUnaSemilla) anyOne) quitarUnaSemilla].
self recuperarPuntosdeVida.
self cantidadDeEnergia: (self nuevaCantidadDeEnergia) .! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'RodolfoCaputo 10/23/2013 22:27'!
conAliados
^(self aliados),({self} asBag)! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'RodolfoCaputo 10/14/2013 01:36'!
concretarAlianzaCon: unGuerrero 
self agregarAliado: unGuerrero.
unGuerrero agregarAliado: self.! !

!Guerrero methodsFor: 'semillas' stamp: 'RodolfoCaputo 10/28/2013 21:16'!
cumpleCondicionesParaComerSemilla
^((self cantidadDeEnergia <200) & (self estaVivo) & (self tieneSemillasDisponibles))! !

!Guerrero methodsFor: 'esferas' stamp: 'RodolfoCaputo 10/28/2013 02:10'!
cumplirDeseo
self tipo elegirDeseoPara: self.! !

!Guerrero methodsFor: 'esferas' stamp: 'RodolfoCaputo 10/28/2013 02:06'!
darEsferaA: unGuerrero
self pasarEsfera: (self esferas anyOne) A: unGuerrero

! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/28/2013 01:41'!
enemigos
	^ enemigos! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/28/2013 01:41'!
enemigos: anObject
	enemigos := anObject! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/28/2013 01:42'!
enemigosVivos
self grupoDeVivosDe: (self enemigos)! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'RodolfoCaputo 10/25/2013 23:50'!
esAliadoDe: unGuerrero
^unGuerrero aliados includes: self.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/24/2013 00:40'!
esBueno
^(self tipo esBueno).! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/17/2013 22:00'!
esDebil 
^(nivelDePelea<15000)! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/17/2013 21:49'!
esMalo
^(self esBueno) not! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'RodolfoCaputo 10/17/2013 23:40'!
esMasGrosoQue: unGuerrero
^( (self nivelesDePeleaConAliados)> (unGuerrero nivelDePelea)).! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
esferas
	^ esferas! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
esferas: anObject
	esferas := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/28/2013 01:53'!
esferasARepartir
	^ esferasARepartir! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/28/2013 01:53'!
esferasARepartir: anObject
	esferasARepartir := anObject! !

!Guerrero methodsFor: 'esferas' stamp: 'RodolfoCaputo 10/28/2013 01:19'!
esferasDeSuGrupo
^self conAliados gather: [ :unAliado | unAliado esferas ]! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'ricardocascallares 10/25/2013 16:37'!
estaMoribundo
^(self tieneAlMenos: 50) not! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 20:54'!
estaMuerto 
^(self estaVivo) not ! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 20:51'!
estaVivo
^self puntosDeVida > 0! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/28/2013 01:42'!
grupoDeVivosDe: unGrupo
^unGrupo select:[:unIntegrante | unIntegrante estaVivo]! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/28/2013 02:15'!
incrementarNivelPeleaAliadosEn: unaCantidad 
self aliados do: [ :unAliado | unAliado incrementarNivelPeleaEn: unaCantidad ]! !

!Guerrero methodsFor: 'ataques(recepcin)' stamp: 'RodolfoCaputo 10/28/2013 02:15'!
incrementarNivelPeleaEn: unaCantidad 
	self nivelDePelea: (self nivelDePelea + unaCantidad ).! !

!Guerrero methodsFor: 'semillas' stamp: 'RodolfoCaputo 10/28/2013 21:16'!
intentarComerSemilla
^ self cumpleCondicionesParaComerSemilla 
ifTrue: [ self comerSemillaDeHermitanio ] 
ifFalse:  [ self error: 'No podes comer Semillas,flaco' ].! !

!Guerrero methodsFor: 'esferas' stamp: 'RodolfoCaputo 10/28/2013 02:08'!
juntarEsferas
self esferasDeSuGrupo do: [ :unaEsfera | self recibirEsfera: unaEsfera]
! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
nivelDePelea
	^ nivelDePelea! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
nivelDePelea: anObject
	nivelDePelea := anObject! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'RodolfoCaputo 10/17/2013 23:41'!
nivelesDePeleaConAliados
^(self conAliados collect:[ :unAliado | unAliado nivelDePelea]) sum.! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'RodolfoCaputo 10/25/2013 23:50'!
noEsAliadoDe: unGuerrero
^(self esAliadoDe: unGuerrero) not! !

!Guerrero methodsFor: 'semillas' stamp: 'Solange 10/27/2013 22:28'!
nuevaCantidadDeEnergia
^((  cantidadDeEnergia +  (0.05* nivelDePelea)) + self cantidadExtraDeEnergia )! !

!Guerrero methodsFor: 'esferas' stamp: 'RodolfoCaputo 10/28/2013 02:05'!
pasarEsfera:unaEsfera A: unGuerrero
unGuerrero recibirEsfera: unaEsfera .
self perderEsfera: unaEsfera

! !

!Guerrero methodsFor: 'esferas' stamp: 'ricardocascallares 10/25/2013 19:57'!
pasarEsferasA:unGuerrero 
self esferas do: [ :unaEsfera | unGuerrero agregarEsfera: unaEsfera.
								self perderEsfera: unaEsfera.]									 ! !

!Guerrero methodsFor: 'esferas' stamp: 'RodolfoCaputo 10/28/2013 01:47'!
pedirDeseo
(self puedeLlamarAShenLong) ifFalse: [ self error: 'Junt todas las esfers o mat a algn aliado. Si no el dragn no sale' ].
self cumplirDeseo.
self repartirEsferas.! !

!Guerrero methodsFor: 'accessing' stamp: 'LoguancioMartin 10/21/2013 20:17'!
perderEnergia: unaCantidad 
	self cantidadDeEnergia: (self cantidadDeEnergia - unaCantidad ).! !

!Guerrero methodsFor: 'esferas' stamp: 'RodolfoCaputo 10/28/2013 02:06'!
perderEsfera: unaEsfera
self esferas remove: unaEsfera ! !

!Guerrero methodsFor: 'ataques(recepcin)' stamp: 'RodolfoCaputo 10/25/2013 23:53'!
perderVida: unosPuntosDeVida
(unosPuntosDeVida>=0) ifTrue:[self puntosDeVida: (self puntosDeVida-unosPuntosDeVida)]! !

!Guerrero methodsFor: 'poderes' stamp: 'RodolfoCaputo 10/28/2013 21:36'!
poderDeAlMenos:unosPuntosDeAtaque para:unGuerrero
^self poderesQuePuedeHacer detect: [ :unPoder | (unPoder puntosDeAtaquePara: self) >= unosPuntosDeAtaque ] ifNone: [ self poderMasFuerteParaAtacarA: unGuerrero ]! !

!Guerrero methodsFor: 'poderes' stamp: 'RodolfoCaputo 10/28/2013 21:36'!
poderMasFuerteParaAtacarA:unGuerrero 
^(self poderesQuePuedeHacer) detectMax: [ :unPoder | unGuerrero puntosDeVidaPerdidosPor: unPoder ] 
! !

!Guerrero methodsFor: 'accessing' stamp: 'ricadocascallares 10/17/2013 20:58'!
poderesAprendidos
	^ poderesAprendidos! !

!Guerrero methodsFor: 'accessing' stamp: 'ricadocascallares 10/17/2013 20:58'!
poderesAprendidos: anObject
	poderesAprendidos := anObject! !

!Guerrero methodsFor: 'poderes' stamp: 'RodolfoCaputo 10/25/2013 13:56'!
poderesQuePuedeHacer
^self poderesAprendidos select: [ :unPoder| self puedeHacer: unPoder ]! !

!Guerrero methodsFor: 'poderes' stamp: 'RodolfoCaputo 10/25/2013 13:56'!
poderesQuePuedeHacerSuGrupo
^ self conAliados gather: [ :unAliado | unAliado poderesQuePuedeHacer]! !

!Guerrero methodsFor: 'esferas' stamp: 'RodolfoCaputo 10/28/2013 01:39'!
potencialesReceptores
^(self aliadosVivos asOrderedCollection),(self enemigosVivos asOrderedCollection)! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'RodolfoCaputo 10/14/2013 16:58'!
puedeAliarseCon: unGuerrero 
^(unGuerrero aceptaA: self) & (self aceptaA: unGuerrero)! !

!Guerrero methodsFor: 'poderes' stamp: 'ricardoCascallares 10/14/2013 23:10'!
puedeHacer: unPoder 
^ unPoder puedeHacersePor: self! !

!Guerrero methodsFor: 'esferas' stamp: 'RodolfoCaputo 10/28/2013 01:21'!
puedeLlamarAShenLong
^(self ySusAliadosTienenTodasLasEsferas) & (self puedePedirDeseo).! !

!Guerrero methodsFor: 'esferas' stamp: 'RodolfoCaputo 10/28/2013 01:26'!
puedePedirDeseo
^self tipo leDejaPedirUnDeseoA: self.! !

!Guerrero methodsFor: 'semillas' stamp: 'LoguancioMartin 10/27/2013 20:38'!
puedePedirSemillaAAliado
^((self aliadosQueCedenUnaSemilla ) size) > 0! !

!Guerrero methodsFor: 'ataques(recepcin)' stamp: 'LoguancioMartin 10/25/2013 20:17'!
puntosDeAtaqueQuePasanElTraje: unosPuntosDeAtaque
^ self traje defender: self de: unosPuntosDeAtaque  ! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 01:09'!
puntosDeVida
	^ puntosDeVida! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 01:10'!
puntosDeVida: anObject
	puntosDeVida := anObject! !

!Guerrero methodsFor: 'ataques(recepcin)' stamp: 'RodolfoCaputo 10/25/2013 22:12'!
puntosDeVidaPerdidosPor: unosPuntosDeAtaque
^self  puntosQueNoAguantaDe: (self puntosDeAtaqueQuePasanElTraje: unosPuntosDeAtaque )
! !

!Guerrero methodsFor: 'ataques(recepcin)' stamp: 'RodolfoCaputo 10/25/2013 22:12'!
puntosQueNoAguantaDe: unosPuntosDeAtaque 
^ unosPuntosDeAtaque- (self aguantePropioPara: unosPuntosDeAtaque) 
! !

!Guerrero methodsFor: 'semillas' stamp: 'Solange 10/26/2013 16:52'!
quitarUnaSemilla
self semillasDelHermitanio: (semillasDelHermitanio- 1)! !

!Guerrero methodsFor: 'esferas' stamp: 'RodolfoCaputo 10/28/2013 01:37'!
receptoresDeEsferas
^self potencialesReceptores first: (7 min: self cantPotencialesReceptores) ! !

!Guerrero methodsFor: 'esferas' stamp: 'RodolfoCaputo 10/28/2013 01:36'!
receptoresDeEsferasTrasDeseo
^(self receptoresDeEsferas empty) ifTrue:[self] ifFalse: [ self receptoresDeEsferas ]! !

!Guerrero methodsFor: 'ataques(recepcin)' stamp: 'LoguancioMartin 10/25/2013 20:29'!
recibir: unosPuntosDeAtaque 
self perderVida:( self puntosDeVidaPerdidosPor: unosPuntosDeAtaque ).
(self traje) fueUsadoPor: self.! !

!Guerrero methodsFor: 'ataques(recepcin)' stamp: 'RodolfoCaputo 10/25/2013 22:34'!
recibir: unPoder de: unGuerrero
self recibir: (unPoder puntosDeAtaquePara: unGuerrero ).
! !

!Guerrero methodsFor: 'esferas' stamp: 'RodolfoCaputo 10/28/2013 02:05'!
recibirEsfera: unaEsfera
self esferas add: unaEsfera ! !

!Guerrero methodsFor: 'semillas' stamp: 'Solange 10/25/2013 23:16'!
recuperarPuntosdeVida
self puntosDeVida: 1000.! !

!Guerrero methodsFor: 'esferas' stamp: 'RodolfoCaputo 10/28/2013 01:57'!
repartirEsferas
self juntarEsferas.
self receptoresDeEsferas do: [ :unReceptor| self darEsferaA: unReceptor ].! !

!Guerrero methodsFor: 'ataques(uso)' stamp: 'RodolfoCaputo 10/25/2013 22:23'!
restarEnergiaAliados: unosJoules
(self aliadosVivosCon: (self energiaNecesariaPorAliado)) do: [ : unAliado| unAliado perderEnergia: unosJoules].! !

!Guerrero methodsFor: 'esferas' stamp: 'RodolfoCaputo 10/28/2013 02:20'!
revivir
self puntosDeVida: 1000.! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
semillasDelHermitanio
	^ semillasDelHermitanio! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
semillasDelHermitanio: anObject
	semillasDelHermitanio := anObject! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'RodolfoCaputo 10/25/2013 14:04'!
tiene: unaCantidad aliadosVivosCon: unaCantidadDeEnergia
^ (self cantAliadosVivosCon: unaCantidadDeEnergia) >= unaCantidad.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 02:58'!
tieneAlMenos: unaCantidadEnergia 
^((self cantidadDeEnergia) > unaCantidadEnergia )! !

!Guerrero methodsFor: 'aliados y alianzas' stamp: 'RodolfoCaputo 10/28/2013 01:25'!
tieneAliadosMuertosAlMenos: unaCantidad 
^self aliadosMuertos size >= unaCantidad ! !

!Guerrero methodsFor: 'poderes' stamp: 'ricadocascallares 10/17/2013 21:06'!
tieneAprendido: unPoder 
^ (self poderesAprendidos)  includes: unPoder ! !

!Guerrero methodsFor: 'semillas' stamp: 'LoguancioMartin 10/27/2013 20:37'!
tieneSemillasDisponibles
^ (semillasDelHermitanio > 0) | self puedePedirSemillaAAliado! !

!Guerrero methodsFor: 'accessing' stamp: 'LoguancioMartin 10/27/2013 20:14'!
tipo
	^ tipo! !

!Guerrero methodsFor: 'accessing' stamp: 'Solange 10/26/2013 16:26'!
tipo: unTipo
tipo := unTipo! !

!Guerrero methodsFor: 'esferas' stamp: 'ricardocascallares 10/25/2013 19:53'!
tomarEsferasDe:unGuerrero 
unGuerrero pasarEsferasA: self ! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
traje
	^ traje! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
traje: anObject
	traje := anObject! !

!Guerrero methodsFor: 'esferas' stamp: 'RodolfoCaputo 10/28/2013 01:19'!
ySusAliadosTienenTodasLasEsferas
^(self class esferasExistentes = self esferasDeSuGrupo)! !

Guerrero subclass: #Monstruo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Monstruo methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/17/2013 22:30'!
aceptariaA: unGuerrero 
^true.! !

!Monstruo methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/24/2013 23:42'!
aguantePropioPara: unosPuntosDeAtaque
^20! !

!Monstruo methodsFor: 'as yet unclassified' stamp: 'Solange 10/25/2013 23:55'!
cantidadExtraDeEnergia
^0! !

!Monstruo methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/24/2013 00:37'!
tipo 
^TipoMalo new! !

Guerrero subclass: #Saiyajin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Saiyajin methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/17/2013 23:38'!
aceptariaA: unGuerrero 
^((unGuerrero esMasGrosoQue: self) not)! !

!Saiyajin methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/24/2013 23:45'!
aguantePropioPara:unosPuntosDeAtaque
^(unosPuntosDeAtaque  * 0,1) + (self cantidadDeEnergia * 0,02)! !

!Saiyajin methodsFor: 'as yet unclassified' stamp: 'Solange 10/25/2013 23:56'!
cantidadExtraDeEnergia
^100* ( aliados size)! !

Guerrero subclass: #Terricola
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/17/2013 22:31'!
aceptariaA: unGuerrero 
^(unGuerrero esBueno & (self meEntra: unGuerrero))! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/25/2013 20:26'!
aguantePropioPara: unosPuntosDeAtaque
	^(unosPuntosDeAtaque * 0.05).! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 18:09'!
aliadosDebiles
^self aliados select: [ :unAliado | unAliado esDebil] ! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:30'!
cantAliadosDebiles
^self aliadosDebiles size! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'Solange 10/25/2013 23:54'!
cantidadExtraDeEnergia 
^200! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/24/2013 00:59'!
meEntra: unGuerrero
^(unGuerrero esDebil & (self cantAliadosDebiles >=5)) not! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 02:29'!
puedeHacer: unPoder
^(super puedeHacer: unPoder) & ( (unPoder energiaQueConsumeDe: self) <500 )! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/24/2013 00:38'!
tipo 
^TipoBueno new! !

Object subclass: #Poderes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

Poderes subclass: #PoderColectivo
	instanceVariableNames: 'aliadosNecesarios energiaNecesariaPorAliado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderColectivo class methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 02:11'!
newConAliadosNecesarios: unaCantidad energiaNecesariaPorAliado: unosJoules 

|unPoder|

unPoder:= self new.

unPoder aliadosNecesarios:  unaCantidad.
unPoder energiaNecesariaPorAliado: unosJoules.


^unPoder! !

!PoderColectivo methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/24/2013 21:50'!
aliadosNecesarios
	^ aliadosNecesarios! !

!PoderColectivo methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/24/2013 21:50'!
aliadosNecesarios: anObject
	aliadosNecesarios := anObject! !

!PoderColectivo methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 14:02'!
condicionesPara: unGuerrero
^ (unGuerrero tieneAlMenos:  200) &  (unGuerrero tiene:  (self aliadosNecesarios) aliadosVivosCon: (self energiaNecesariaPorAliado))! !

!PoderColectivo methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/24/2013 22:30'!
energiaNecesariaPorAliado
	^ energiaAliados! !

!PoderColectivo methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/24/2013 22:30'!
energiaNecesariaPorAliado: anObject
	energiaAliados := anObject! !

!PoderColectivo methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 00:20'!
energiaQueConsumeDe: unGuerrero
^200! !

!PoderColectivo methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/25/2013 22:23'!
generarConsecuenciasEn: unGuerrero
super generarConsecuenciasEn: unGuerrero.
unGuerrero restarEnergiaAliados: (self energiaNecesariaPorAliado)! !

!PoderColectivo methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 17:14'!
puntosAtaquePara: unGuerrero 
^(200+( (self energiaNecesariaPorAliado) * (unGuerrero cantAliadosVivosCon: (self energiaNecesariaPorAliado))))! !

Poderes subclass: #PoderLiviano
	instanceVariableNames: 'puntosDeAtaque'
	classVariableNames: 'energiaQueConsume'
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderLiviano class methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 02:14'!
newConPuntosDeAtaque: unaCantidad 

|unPoder|

unPoder:= self new.

unPoder puntosDeAtaque:  unaCantidad.

^unPoder! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/24/2013 22:25'!
condicionesPara: unGuerrero
^ (unGuerrero tieneAlMenos: 50).! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 00:20'!
energiaQueConsumeDe: unGuerrero
^0! !

!PoderLiviano methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 01:37'!
puntosDeAtaque
	^ puntosDeAtaque! !

!PoderLiviano methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 01:37'!
puntosDeAtaque: anObject
	puntosDeAtaque := anObject! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 19:36'!
puntosDeAtaquePara: unGuerrero 
^ self puntosDeAtaque ! !

Poderes subclass: #PoderPotente
	instanceVariableNames: 'potencia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderPotente class methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 02:15'!
newConPotencia: unaCantidad 

|unPoder|

unPoder:= self new.

unPoder potencia:  unaCantidad.

^unPoder! !

!PoderPotente methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/24/2013 22:26'!
condicionesPara: unGuerrero
^ true! !

!PoderPotente methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 00:20'!
energiaQueConsumeDe: unGuerrero 
^ unGuerrero cantidadDeEnergia * 0.25! !

!PoderPotente methodsFor: 'accessing' stamp: 'ricadocascallares 10/17/2013 19:39'!
potencia
	^ potencia! !

!PoderPotente methodsFor: 'accessing' stamp: 'ricadocascallares 10/17/2013 19:39'!
potencia: anObject
	potencia := anObject! !

!PoderPotente methodsFor: 'as yet unclassified' stamp: 'ricadocascallares 10/17/2013 19:38'!
puntosDeAtaquePara: unGuerrero
^ (unGuerrero nivelDePelea )/ 500 * (self potencia)! !

Poderes subclass: #PoderVengativo
	instanceVariableNames: 'aliadosMuertosNecesarios'
	classVariableNames: 'energiaQueConsume'
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderVengativo class methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/25/2013 02:15'!
aliadosMuertosNecesarios! !

!PoderVengativo class methodsFor: 'accessing' stamp: 'ricadocascallares 10/17/2013 21:27'!
energiaQueConsume
	^ energiaQueConsume! !

!PoderVengativo class methodsFor: 'accessing' stamp: 'ricadocascallares 10/17/2013 21:27'!
energiaQueConsume: anObject
	energiaQueConsume := anObject! !

!PoderVengativo class methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/25/2013 02:16'!
newConAliadosMuertosNecesarios: unaCantidad 

|unPoder|

unPoder:= self new.

unPoder aliadosMuertosNecesarios:  unaCantidad.

^unPoder! !

!PoderVengativo methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/24/2013 21:55'!
aliadosMuertosNecesarios
	^ aliadosMuertosNecesarios! !

!PoderVengativo methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/24/2013 21:55'!
aliadosMuertosNecesarios: anObject
	aliadosMuertosNecesarios := anObject! !

!PoderVengativo methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/28/2013 01:25'!
condicionesPara: unGuerrero
^ (unGuerrero tieneAlMenos: ((self class) energiaQueConsume) )& (unGuerrero tieneAliadosMuertosAlMenos: (self aliadosMuertosNecesarios)) & (unGuerrero cantidadAliadosVivos >= 1)! !

!PoderVengativo methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 00:20'!
energiaQueConsumeDe: unGuerrero
^ (self class) energiaQueConsume! !

!PoderVengativo methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 22:47'!
generarConsecuenciasEn: unGuerrero
super generarConsecuenciasEn: unGuerrero.
unGuerrero perderVida: (0.2*(self puntosDeAtaquePara: unGuerrero)).
(unGuerrero estaMuerto) ifTrue: [unGuerrero pasarEsferasA: (unGuerrero aliadoVivo)].! !

!PoderVengativo methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/24/2013 22:15'!
puntosDeAtaquePara: unGuerrero
^250* unGuerrero cantidadAliadosMuertos! !

!Poderes methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 22:20'!
generarConsecuenciasEn: unGuerrero
unGuerrero perderEnergia: (self energiaQueConsumeDe: unGuerrero).
! !

!Poderes methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 02:30'!
puedeHacersePor: unGuerrero
^(unGuerrero tieneAprendido: self) & (self condicionesPara: unGuerrero)
! !

!Poderes methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/24/2013 22:06'!
serRealizadoPor: unGuerrero 
^(self puedeHacersePor:  unGuerrero) ifTrue: [ unGuerrero  ]"sin terminar"! !

Object subclass: #TipoBueno
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!TipoBueno methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/28/2013 02:17'!
elegirDeseoPara: unGuerrero
unGuerrero aliadoMuertoMasFuerte revivir.! !

!TipoBueno methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:39'!
esBueno
^true! !

!TipoBueno methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/28/2013 01:25'!
leDejaPedirUnDeseoA: unGuerrero
^ unGuerrero tieneAliadosMuertosAlMenos: 1! !

!TipoBueno methodsFor: 'as yet unclassified' stamp: 'Solange 10/26/2013 16:24'!
puededarUnaSemilla: unGuerrero
^(unGuerrero semillasDelHermitanio )>0! !

Object subclass: #TipoMalo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!TipoMalo methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/28/2013 02:15'!
elegirDeseoPara: unGuerrero
unGuerrero incrementarNivelPeleaEn: 50.
unGuerrero incrementarNivelPeleaAliadosEn: 10.! !

!TipoMalo methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:39'!
esBueno
^false! !

!TipoMalo methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/28/2013 01:26'!
leDejaPedirUnDeseoA: unGuerrero
^true! !

!TipoMalo methodsFor: 'as yet unclassified' stamp: 'Solange 10/26/2013 16:25'!
puededarUnaSemilla: unGuerrero
^(unGuerrero semillasDelHermitanio )>1! !

Object subclass: #Traje
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

Traje subclass: #NoTraje
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!NoTraje methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 21:57'!
defender: unGuerrero de: unosPuntosDeAtaque
	^unosPuntosDeAtaque! !

!Traje methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 21:57'!
defender: unGuerrero de: unosPuntosDeAtaque
	^( unosPuntosDeAtaque * 0.90).! !

!Traje methodsFor: 'as yet unclassified' stamp: 'LoguancioMartin 10/25/2013 14:15'!
fueUsadoPor: unGuerrero
	^unGuerrero .! !

Traje subclass: #TrajeEntrenamiento
	instanceVariableNames: 'ataquesRecibidos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!TrajeEntrenamiento methodsFor: 'accessing' stamp: 'LoguancioMartin 10/14/2013 22:46'!
ataquesRecibidos
	^ ataquesRecibidos! !

!TrajeEntrenamiento methodsFor: 'accessing' stamp: 'LoguancioMartin 10/14/2013 22:46'!
ataquesRecibidos: anObject
	ataquesRecibidos := anObject! !

!TrajeEntrenamiento methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/28/2013 02:15'!
fueUsadoPor: unGuerrero
	ataquesRecibidos := ataquesRecibidos +1.
	unGuerrero perderEnergia: 20.
	(ataquesRecibidos =3) ifTrue: [ self ataquesRecibidos: 0.
									unGuerrero incrementarNivelPeleaEn: 100. ].
 ! !

Traje subclass: #TrajeEspecial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!TrajeEspecial methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/25/2013 21:58'!
defender: unGuerrero de: unosPuntosDeAtaque
	^(super defender: unGuerrero de: unosPuntosDeAtaque)-20.! !
